Index: /trunk/Dockerfile
===================================================================
--- /trunk/Dockerfile	(revision 981)
+++ /trunk/Dockerfile	(revision 982)
@@ -18,4 +18,5 @@
     libxslt1.1 \
     gdal-bin \
+    libcgal13 \
     python3 \
     r-base \
@@ -108,7 +109,8 @@
     libxml2-dev \
     libxslt1-dev \
+    libcgal-dev \
 "
 WORKDIR /zoo-project
-COPY ./zoo-project/zoo-services/utils/status ./zoo-project/zoo-services/utils/status
+COPY ./zoo-project/zoo-services ./zoo-project/zoo-services
 
 # From zoo-kernel
@@ -133,6 +135,34 @@
     && make install \
     \
+    && cd ../../cgal \
+    && make \
+    && cp cgi-env/* /usr/lib/cgi-bin/ \
+    \
+    && cd .. \
+    && cd ../zoo-services/ogr/base-vect-ops \
+    && make \
+    && cp cgi-env/* /usr/lib/cgi-bin/ \
+    && cd ../.. \
+    \
+    && cd ../zoo-services/gdal/ \
+    && for i in contour dem grid profile translate warp ; do cd $i ; make && cp cgi-env/* /usr/lib/cgi-bin/ ; cd .. ; done \
+    \
     && apt-get purge -y --auto-remove -o APT::AutoRemove::RecommendsImportant=false $BUILD_DEPS \
     && rm -rf /var/lib/apt/lists/*
+
+#
+# Optional zoo demos download.
+#
+FROM base AS demos
+ARG DEBIAN_FRONTEND=noninteractive
+ARG BUILD_DEPS=" \
+    git \
+"
+WORKDIR /zoo-project
+
+RUN set -ex \
+    && apt-get update && apt-get install -y --no-install-recommends $BUILD_DEPS \
+    \
+    && git clone https://github.com/ZOO-Project/examples.git 
 
 #
@@ -157,4 +187,9 @@
 COPY --from=builder2 /usr/com/zoo-project/ /usr/com/zoo-project/
 
+# From optional zoo demos
+COPY --from=demos /zoo-project/examples/data/ /usr/com/zoo-project/
+COPY --from=demos /zoo-project/examples/ /var/www/html/
+
+
 RUN set -ex \
     && apt-get update && apt-get install -y --no-install-recommends $RUN_DEPS \
Index: /trunk/docker-compose.yml
===================================================================
--- /trunk/docker-compose.yml	(revision 981)
+++ /trunk/docker-compose.yml	(revision 982)
@@ -14,4 +14,6 @@
       - ./zoo-project/zoo-services/utils/open-api/templates/index.html:/var/www/index.html
       - ./zoo-project/zoo-services/utils/open-api/static:/var/www/html/static
+      - ../zoo-demos/zoo-demos-202102/examples:/var/www/html/examples
+      - ../zoo-demos/zoo-demos-202102/data/topofr.tif:/usr/com/zoo-project/topofr.tif
     depends_on:
       - pgbouncer
Index: /trunk/zoo-project/HISTORY.txt
===================================================================
--- /trunk/zoo-project/HISTORY.txt	(revision 981)
+++ /trunk/zoo-project/HISTORY.txt	(revision 982)
@@ -1,2 +1,5 @@
+Version 1.8.1
+  * Deploy demo HTML UI from github from the Dockerfile
+  * Add demo ZOO-Services build in the Dockerfile
 Version 1.8.0
   * Support raw response in OGC API - Processes
Index: /trunk/zoo-project/zoo-kernel/Makefile.in
===================================================================
--- /trunk/zoo-project/zoo-kernel/Makefile.in	(revision 981)
+++ /trunk/zoo-project/zoo-kernel/Makefile.in	(revision 982)
@@ -4,5 +4,5 @@
 
 version.h: Makefile
-	echo "#define ZOO_VERSION \"1.8.0 `svnversion`\"" > version.h
+	echo "#define ZOO_VERSION \"1.8.1-dev `svnversion`\"" > version.h
 	echo "@ETC_DEF@" >> version.h
 	echo "#define LOCALEDIR \"@localedir@\"" >>  version.h
Index: /trunk/zoo-project/zoo-kernel/configure.ac
===================================================================
--- /trunk/zoo-project/zoo-kernel/configure.ac	(revision 981)
+++ /trunk/zoo-project/zoo-kernel/configure.ac	(revision 982)
@@ -1,3 +1,3 @@
-AC_INIT([ZOO Kernel], [1.8.0], [bugs@zoo-project.org])
+AC_INIT([ZOO Kernel], [1.8.1-dev], [bugs@zoo-project.org])
 
 AC_CONFIG_MACRO_DIR([macros])
Index: /trunk/zoo-project/zoo-kernel/server_internal.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/server_internal.c	(revision 981)
+++ /trunk/zoo-project/zoo-kernel/server_internal.c	(revision 982)
@@ -375,5 +375,5 @@
   zStatStruct f_status;
   int s=zStat(filename, &f_status);
-  sprintf(rsize,"%lld",f_status.st_size);
+  sprintf(rsize,"%ld",f_status.st_size);
   if(getMap(content,"storage")==NULL){
     map* tmpMap1=getMap(content,"value");
Index: /trunk/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 981)
+++ /trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 982)
@@ -3418,11 +3418,7 @@
   signal (SIGABRT, donothing);
 #endif
-    fprintf(stderr,"%s %d \n",__FILE__,__LINE__);
-    fflush(stderr);
 
   if (((int) zGetpid ()) != cpid || cgiSid != NULL)
     {
-    fprintf(stderr,"%s %d \n",__FILE__,__LINE__);
-    fflush(stderr);
       if (eres == SERVICE_SUCCEEDED)
 #ifdef USE_CALLBACK
Index: /trunk/zoo-project/zoo-services/cgal/voronoi.c
===================================================================
--- /trunk/zoo-project/zoo-services/cgal/voronoi.c	(revision 981)
+++ /trunk/zoo-project/zoo-services/cgal/voronoi.c	(revision 982)
@@ -46,7 +46,7 @@
 
   int Voronoi(maps*& conf,maps*& inputs,maps*& outputs){
-    //#ifdef DEBUG
+#ifdef DEBUG
     fprintf(stderr,"\nService internal print\nStarting\n");
-    //#endif
+#endif
     //return SERVICE_FAILED;
     maps* cursor=inputs;
@@ -56,6 +56,8 @@
     tmpm=getMapFromMaps(inputs,"InputPoints","value");
 
+#ifdef DEBUG
     fprintf(stderr," **** %s %d\n",__FILE__,__LINE__);
     fflush(stderr);
+#endif
 
     OGRRegisterAll();
@@ -67,6 +69,8 @@
       return SERVICE_FAILED;
     }
+#ifdef DEBUG
     fprintf(stderr," **** %s %d\n",__FILE__,__LINE__);
     fflush(stderr);
+#endif
     
     Triangulation T;
@@ -204,5 +208,4 @@
 	const Pointz p1=tmp->source();
 	const Pointz p2=tmp->target();
-	fprintf(stderr,"P1 %d %d | P2 %d %d\n",p1.x(),p1.y(),p2.x(),p2.y());
 #ifdef DEBUG
 	fprintf(stderr,"P1 %d %d | P2 %d %d\n",p1.x(),p1.y(),p2.x(),p2.y());